;;; **********************************************************************
;;; Copyright (C) 2005-2006 Todd Ingalls, Michael Klingbeil, Rick Taube
;;; This program is free software; you can redistribute it and/or   
;;; modify it under the terms of the Lisp Lesser Gnu Public License.
;;; See http://www.cliki.net/LLGPL for the text of this agreement.
;;; **********************************************************************

;;; $Revision: 1.6 $
;;; $Date: 2006/04/16 13:10:39 $

(in-package :cl-user)

#+cm
(unless (and (numberp (cm::cm-version-number))
	     (>= (cm::cm-version-number) #x291))
  (error "RTS version 2 requires CM 2.9.1 or higher."))

;; if CFFI isn't already loaded or on *central-registry*, search for
;; it first under this directory then under the parent directory of
;; this directory, else signal an error.

#-cffi
(flet ((cffi-probe (dir)
           (let ((asd
                  (first (directory
                          (make-pathname :name "cffi" :type "asd"
                                         :directory
                                         (append 
                                          (pathname-directory dir)
                                          (list :wild))
                                         :defaults dir)))))
             (if asd (push asd asdf:*central-registry*) nil))))
    (let* ((thisdir (make-pathname :type nil :name nil
                                   :defaults (truename *load-pathname*)))
           (rootdir (make-pathname :directory
                                   (butlast (pathname-directory thisdir))
                                   :defaults thisdir)))
      (or (cffi-probe thisdir)
          (cffi-probe rootdir)
          (error "Atempt to load RTS without CFFI loaded."))))  

;; fucking clisp nonsense
#+clisp
(set-dispatch-macro-character #\# #\_ (lambda (&rest args) args))

(asdf:defsystem :rts
  :description "real time system for Common Music"
  :author "Todd Ingalls, Michael Klingbeil, Rick Taube"
  :licence "LLGPL"
  :depends-on (cffi)
  :serial t
  :components (
	       (:file "cffi-scheduler")
               #+cm (:file "cm-scheduler")
               ))







